
local Mounted = Mounted
Mounted.modules = Mounted.modules or {}
Mounted.modules.SHAMAN = {}
local SHAMAN = Mounted.modules.SHAMAN
local OnUpdate = function(self, ...) if self['MoveCheck'] then return self['MoveCheck'](self, ...) end end

-- nils out tables and subtables so nothing is left at the end
local function DelTable(t)
	setmetatable(t, nil)
	for k in pairs(t) do
		if type(t[k]) == "table" then
			DelTable(t[k])
		end
		t[k] = nil
	end
	return nil
end

function SHAMAN:LoadModule()
	local _, class = UnitClass("player")
	if class ~= 'SHAMAN' then
		OnUpdate = nil
		Mounted.modules.SHAMAN = DelTable(Mounted.modules.SHAMAN)
		return
	end
	SHAMAN = CreateFrame("frame")
	Mounted.spellmounts = Mounted.spellmounts or {}
	Mounted.spellmounts[2645] = 'g,40' --travel
	
	-- add druid module defaults the enable switch should be per character
	Mounted.defaults.char.Module.SHAMAN = {
		['move'] = true,
	}
	SHAMAN:SetScript("OnUpdate", OnUpdate)
	SHAMAN:RegisterEvent("PLAYER_REGEN_DISABLED")
	SHAMAN:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
end

function SHAMAN:PLAYER_REGEN_DISABLED()
	SHAMAN.isMoving = false
end

function SHAMAN:UNIT_SPELLCAST_SUCCEEDED(event, arg1, arg2)
	if arg1 == 'player' and arg2 == GetSpellInfo(2645) then
		Mounted:SelectMacro(true)
	end
end

function SHAMAN:SPELL_UPDATE_USABLE() -- gets called with from mounted lua
	SHAMAN.isMoving = false
end

SHAMAN.isMoving = false
local isSwimmingOld = false
function SHAMAN:MoveCheck()
	if not InCombatLockdown() then
		if Mounted.db.char.Module.SHAMAN.move then
			if GetUnitSpeed('player') ~= 0 and not IsFlying() then
				if not SHAMAN.isMoving then
					SHAMAN.isMoving = true
					if IsOutdoors() and Mounted.db.char.mounts['g']['40'][2645] then
						return EditMacro(GetMacroIndexByName("Mounted"), "Mounted", 1, string.format('#showtooltip\n/cast %s()', GetSpellInfo(2645)))
					end
				end
			elseif not IsFlying() then
				if SHAMAN.isMoving then
					SHAMAN.isMoving = false
					Mounted:SelectMacro(true)
				end
			end
		end
	end
end
